Name:           sudo
Version:        1.8.19p2
Release:        %mkrel 1
Epoch:          1
Summary:        Allows command execution as root for specified users
License:        GPLv2+
Group:          System/Base
URL:            http://www.sudo.ws/sudo
Source0:        http://www.sudo.ws/sudo/dist/%{name}-%{version}%{?pre}.tar.gz
Source1:        http://www.sudo.ws/sudo/dist/%{name}-%{version}%{?pre}.tar.gz.sig
Source2:        sudo.pamd
Source3:        sudoers
Patch1:         sudo-1.6.7p5-strip.patch
Patch2:         sudo-1.7.2p1-envdebug.patch
BuildRequires:  audit-devel
BuildRequires:  bison
BuildRequires:  groff-for-man
BuildRequires:  libcap-devel
BuildRequires:  openldap-devel
BuildRequires:  pam-devel
Requires(pre):  openldap

%description
Sudo (superuser do) allows a system administrator to give certain users (or
groups of users) the ability to run some (or all) commands as root while
logging all commands and arguments. Sudo operates on a per-command basis.
It is not a replacement for the shell. Features include: the ability to
restrict what commands a user may run on a per-host basis, copious logging
of each command (providing a clear audit trail of who did what), a
configurable timeout of the sudo command, and the ability to use the same
configuration file (sudoers) on many different machines.

%package devel
Summary:        Development files for sudo plugins
Group:          Development/C
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    devel
Development files for compiling sudo plugins.

%prep
%setup -q -n %{name}-%{version}%{?pre}
%patch1 -p1 -b .strip
%patch2 -p1 -b .envdebug

# fix attribs
find -name "Makefile.*" | xargs perl -pi -e "s|-m 0444|-m 0644|g"


%build
# handle newer autoconf
rm -f acsite.m4
mv aclocal.m4 acinclude.m4
autoreconf -fv --install

%serverbuild
export CFLAGS="%{optflags} -D_GNU_SOURCE"

%configure2_5x \
        --without-rpath \
        --with-logging=both \
        --with-logfac=authpriv \
        --with-logpath=%{_logdir}/sudo.log \
        --with-editor=/bin/vi \
	--disable-root-mailer \
        --enable-log-host \
        --with-pam \
        --with-pam-login \
        --with-env-editor \
        --with-noexec=no \
        --with-linux-audit \
        --with-ignore-dot \
        --with-tty-tickets \
        --with-ldap \
        --with-ldap-conf-file=%{_sysconfdir}/nslcd.conf \
        --with-ldap-secret-file=%{_sysconfdir}/nslcd.conf \
        --with-secure-path="/sbin:%{_sbindir}:/bin:%{_bindir}:/usr/local/bin:/usr/local/sbin" \
        --with-passprompt="[sudo] password for %p: " \
        --with-plugindir=%{_libdir}/sudo

%make

%install
install -d %{buildroot}/usr
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}%{_sysconfdir}/sudoers.d
install -d %{buildroot}%{_sysconfdir}/pam.d
install -d %{buildroot}%{_var}/db/sudo
install -d %{buildroot}%{_var}/db/sudo/lectured
install -d %{buildroot}%{_logdir}/sudo
install -d %{buildroot}%{_logdir}/sudo-io

%makeinstall_std install_uid=$UID install_gid=$(id -g) sudoers=uid=$UID sudoers_gid=$(id -g)

install -m0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/sudo
install -m0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/sudoers
install -m0755 plugins/sudoers/sudoers2ldif %{buildroot}%{_bindir}

# Installing logrotated file
cat <<END >%{buildroot}%{_sysconfdir}/logrotate.d/sudo
%{_logdir}/sudo.log {
    missingok
    monthly
    compress
}
END

cat > %{buildroot}%{_sysconfdir}/pam.d/sudo << EOF
#%PAM-1.0
auth            include         system-auth
account         include         system-auth
password        include         system-auth
session         optional        pam_keyinit.so revoke
session         required        pam_limits.so
EOF

cat > %{buildroot}%{_sysconfdir}/pam.d/sudo-i << EOF
#%PAM-1.0
auth            include         sudo
account         include         sudo
password        include         sudo
session         optional        pam_keyinit.so force revoke
session         required        pam_limits.so
EOF

# so that strip can touch it...
chmod 755 %{buildroot}%{_bindir}/*
chmod 755 %{buildroot}%{_sbindir}/*

# (tpg) create the missing log file
touch %{buildroot}%{_logdir}/sudo.log

# move the lib to a common place
mv %{buildroot}%{_libexecdir}/sudo/* %{buildroot}%{_libdir}/
rm -rf %{buildroot}%{_libexecdir}/sudo

# cleanup
rm -rf %{buildroot}%{_datadir}/examples samples
cp -rp examples samples
rm -f samples/Makefile*
# already install in _bindir
rm -f %{buildroot}%{_docdir}/%{name}/sudoers2ldif
# too big
rm -f %{buildroot}%{_docdir}/%{name}/ChangeLog

find %{buildroot} -type f -name "*.la" | xargs rm

%find_lang sudo
%find_lang sudoers

cat sudo.lang sudoers.lang > sudo_all.lang
rm sudo.lang sudoers.lang

%check
make check

%post
/bin/chmod 0440 %{_sysconfdir}/sudoers || :
%create_ghostfile %{_logdir}/sudo.log root root 600

%files -f sudo_all.lang
%doc samples
%{_docdir}/%{name}/CONTRIBUTORS
%{_docdir}/%{name}/LICENSE
%{_docdir}/%{name}/NEWS
%{_docdir}/%{name}/HISTORY
%{_docdir}/%{name}/README
%{_docdir}/%{name}/README.LDAP
%{_docdir}/%{name}/TROUBLESHOOTING
%{_docdir}/%{name}/UPGRADE
%{_docdir}/%{name}/schema.ActiveDirectory
%{_docdir}/%{name}/schema.OpenLDAP
%{_docdir}/%{name}/schema.iPlanet
%{_docdir}/%{name}/examples/*.conf
%{_docdir}/%{name}/examples/sudoers
%attr(0440,root,root) %config(noreplace) %{_sysconfdir}/sudoers
%attr(0750,root,root) %dir %{_sysconfdir}/sudoers.d/
%config(noreplace) %{_sysconfdir}/logrotate.d/sudo
%config(noreplace) %{_sysconfdir}/pam.d/sudo
%config(noreplace) %{_sysconfdir}/pam.d/sudo-i
%attr(0755,root,root) %{_bindir}/sudoers2ldif
%attr(4111,root,root) %{_bindir}/sudo
%{_bindir}/sudoedit
%attr(0111,root,root) %{_bindir}/sudoreplay
%attr(0755,root,root) %{_sbindir}/visudo
%ghost %{_logdir}/sudo.log
%{_mandir}/*/*
%attr(0700,root,root) %dir %{_var}/db/sudo
%attr(0700,root,root) %dir %{_var}/db/sudo/lectured
%attr(0750,root,root) %dir %{_logdir}/sudo-io
%attr(0755,root,root) %{_libdir}/sudo/group_file.so
%attr(0755,root,root) %{_libdir}/sudo/sudoers.so
%attr(0755,root,root) %{_libdir}/sudo/system_group.so
%{_libdir}/libsudo_util.so.0
%attr(0755,root,root) %{_libdir}/libsudo_util.so.*.*
%{_tmpfilesdir}/sudo.conf

%files devel
%doc plugins/{group_file,sample}
%{_includedir}/sudo_plugin.h
%{_mandir}/man8/sudo_plugin.8*
%{_libdir}/libsudo_util.so


%changelog
* Wed Apr 05 2017 luigiwalser <luigiwalser> 1:1.8.19p2-1.mga6
+ Revision: 1095936
- 1.8.19p2

* Sun Jan 01 2017 luigiwalser <luigiwalser> 1:1.8.19p1-1.mga6
+ Revision: 1078932
- 1.8.19p1

* Fri Nov 11 2016 luigiwalser <luigiwalser> 1:1.8.18p1-1.mga6
+ Revision: 1066574
- 1.8.18p1 (fixes CVE-2016-7076)

* Tue Oct 04 2016 luigiwalser <luigiwalser> 1:1.8.18-1.mga6
+ Revision: 1058668
- 1.8.18
- add --disable-root-mailer configure option

* Wed Sep 14 2016 tv <tv> 1:1.8.17p1-2.mga6
+ Revision: 1052892
- sudoers: allow wheel group by default (mga#19342)

* Fri Jul 22 2016 luigiwalser <luigiwalser> 1:1.8.17p1-1.mga6
+ Revision: 1043128
- 1.8.17p1 (fixes CVE-2016-8239)

* Mon Jun 06 2016 luigiwalser <luigiwalser> 1:1.8.15-3.mga6
+ Revision: 1020458
- remove INPUTRC from env_keep due to possible info leak (rhbz#1339935)

* Wed Feb 17 2016 umeabot <umeabot> 1:1.8.15-2.mga6
+ Revision: 962964
- Mageia 6 Mass Rebuild

  + luigiwalser <luigiwalser>
    - use nslcd.conf for ldap config instead of ldap.conf which no longer is used

* Mon Nov 09 2015 luigiwalser <luigiwalser> 1:1.8.15-1.mga6
+ Revision: 900136
- 1.8.15 (fixes CVE-2015-5602)
- remove upstreamed patches 3 and 4

* Wed Sep 23 2015 blino <blino> 1:1.8.12-3.mga6
+ Revision: 882306
- fix doc file list for rpm 4.13 (now errors out on unpackaged files in docdir)

  + luigiwalser <luigiwalser>
    - disable visiblepw instead of enable requiretty in sudoers (mga#16590)

* Sat Feb 21 2015 luigiwalser <luigiwalser> 1:1.8.12-2.mga5
+ Revision: 816279
- add upstream patch to fix linking error with libsudo_util.so
- add upstream patch to fix handling when crypt() returns NULL

* Sat Feb 14 2015 oden <oden> 1:1.8.12-1.mga5
+ Revision: 814926
- bump release
- 1.8.12

* Wed Oct 15 2014 umeabot <umeabot> 1:1.8.10p3-4.mga5
+ Revision: 750013
- Second Mageia 5 Mass Rebuild

* Thu Oct 09 2014 luigiwalser <luigiwalser> 1:1.8.10p3-3.mga5
+ Revision: 737649
- add upstream patch to blacklist new-style bash function environment variables

* Tue Sep 16 2014 umeabot <umeabot> 1:1.8.10p3-2.mga5
+ Revision: 689578
- Mageia 5 Mass Rebuild

* Wed May 14 2014 luigiwalser <luigiwalser> 1:1.8.10p3-1.mga5
+ Revision: 622656
- 1.8.10p3

* Wed Mar 19 2014 luigiwalser <luigiwalser> 1:1.8.10p2-1.mga5
+ Revision: 605632
- 1.8.10p2

* Sat Mar 15 2014 luigiwalser <luigiwalser> 1:1.8.10p1-1.mga5
+ Revision: 603980
- 1.8.10p1

* Tue Mar 11 2014 luigiwalser <luigiwalser> 1:1.8.10-1.mga5
+ Revision: 601985
- 1.8.10

* Fri Feb 14 2014 luigiwalser <luigiwalser> 1:1.8.9p5-1.mga5
+ Revision: 591436
- 1.8.9p5

* Thu Nov 07 2013 tv <tv> 1:1.8.8-3.mga4
+ Revision: 549844
- disable patch4 (thus fixing iurt) (mga#11374)

* Mon Oct 21 2013 umeabot <umeabot> 1:1.8.8-2.mga4
+ Revision: 538827
- Mageia 4 Mass Rebuild

* Wed Oct 02 2013 luigiwalser <luigiwalser> 1:1.8.8-1.mga4
+ Revision: 490475
- 1.8.8

* Sun Jul 07 2013 luigiwalser <luigiwalser> 1:1.8.7-1.mga4
+ Revision: 451036
- 1.8.7
- remove upstreamed patch 3
- update files list

* Fri May 24 2013 luigiwalser <luigiwalser> 1:1.8.6p8-1.mga4
+ Revision: 426728
- 1.8.6p8

* Thu Feb 28 2013 luigiwalser <luigiwalser> 1:1.8.6p7-1.mga3
+ Revision: 400679
- 1.8.6p7

* Tue Feb 12 2013 luigiwalser <luigiwalser> 1:1.8.6p6-1.mga3
+ Revision: 397943
- 1.8.6p6

* Thu Jan 31 2013 luigiwalser <luigiwalser> 1:1.8.6p5-1.mga3
+ Revision: 393626
- 1.8.6p5

* Mon Jan 14 2013 umeabot <umeabot> 1:1.8.6p3-3.mga3
+ Revision: 383578
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Jan 06 2013 pterjan <pterjan> 1:1.8.6p3-2.mga3
+ Revision: 340151
- Place plugins in /usr/lib/sudo/ instead of libexecdir, they are .so to dlopen

* Sun Sep 23 2012 luigiwalser <luigiwalser> 1:1.8.6p3-1.mga3
+ Revision: 296897
- 1.8.6p3

* Sat Sep 15 2012 luigiwalser <luigiwalser> 1:1.8.6p1-1.mga3
+ Revision: 294256
- 1.8.6p1
- rediff patch 3
- remove upstreamed patch 5

* Sun Jul 29 2012 luigiwalser <luigiwalser> 1:1.8.5p1-1.mga3
+ Revision: 275808
- 1.8.5p1
- add pipelist and sssd-support patches from mdv
- other minor syncing with mdv package

* Thu May 17 2012 luigiwalser <luigiwalser> 1:1.8.3p2-2.mga3
+ Revision: 235868
- add patch for CVE-2012-2337 (improper netmask matching)

* Mon Jan 30 2012 boklm <boklm> 1:1.8.3p2-1.mga2
+ Revision: 203379
- Version 1.8.3.p2 (fixing format string vulnerability)

* Mon Oct 31 2011 fwang <fwang> 1:1.8.3p1-1.mga2
+ Revision: 160282
- new version 1.8.3p1

* Fri Oct 07 2011 shlomif <shlomif> 1:1.8.2-1.mga2
+ Revision: 152774
- New version of sudo - 1.8.2. Patch to SPEC contributed by barjac.

  + rtp <rtp>
    - fix build with noexec disabled
    - fix file list

  + tv <tv>
    - drop patch 5 (merged upstream)
    - new release

* Thu Mar 24 2011 pterjan <pterjan> 1:1.8.0-4.mga1
+ Revision: 76858
- Fix missing epoch in -devel dependency

* Wed Mar 23 2011 blino <blino> 1:1.8.0-3.mga1
+ Revision: 75835
- fix exit value of sudo -l command in sudoers module (from upstream)

* Mon Mar 21 2011 dmorgan <dmorgan> 1:1.8.0-2.mga1
+ Revision: 75107
- Add upstream patch for fix the use of the -n option ( Bug #475)

* Sat Mar 19 2011 boklm <boklm> 1:1.8.0-1.mga1
+ Revision: 74482
- update to version 1.8.0
- removed patches :
 * sudo-1.7.4p4-auditconn.patch: removed from fedora package
 * sudo-1.7.4p3-sudolist.patch: removed from fedora package
 * sudo-1.7.4p4-sudoi.patch: applied upstream
 * sudo-1.7.4p4-getgrouplist.patch: does not apply to new version, and
   needs small modifications. Fixing Red Hat bug #235915, but not applied
   upstream since 2007.

  + blino <blino>
    - imported package sudo

